Unit qtshe_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure qtshe(var RINT :Array of Extended; H1 :Extended; H2 :Extended;
                var F :Array of Extended; N :Integer; M :Integer);

implementation

procedure qtshe(var RINT :Array of Extended; H1 :Extended; H2 :Extended;
                var F :Array of Extended; N :Integer; M :Integer);
var
I,J :Integer;
A1,A2,A3,B1,B2,B3,C,C2,F12 :Extended;
A :Array [0..3] of Extended;
label
_10,_20,_30,_40,_50,_60,_70;
{  -  FORTRAN }
function AR(R1: Extended; R2: Extended; R3: Extended; R4: Extended): Extended;
begin
Result := B1*(R1 - R3) + B2*R2 + B3*R4;
end;
{   - }
begin
C := H1*H2/9.e0;
C2 := C/4.e0;
B1 := 5.e0/16.e0;
B2 := 15.e0/16.e0;
B3 := 1.e0/16.e0;
for J:=1 to 4 do
 begin
  A[J-1] := AR(F[0+(J-1)*N],F[1+(J-1)*N],F[2+(J-1)*N],F[3+(J-1)*N]);
_10:
 end;
F12 := AR(A[0],A[1],A[2],A[3]);
A1 := AR(F[0+0*N],F[0+1*N],F[0+2*N],F[0+3*N]);
A2 := AR(F[1+0*N],F[1+1*N],F[1+2*N],F[1+3*N]);
RINT[1+1*N] := (F[0+0*N] + F[1+0*N] + F[0+1*N] + F[1+1*N] + 16.e0*F12 +
    4.e0*(A1 + A2 + A[0] + A[1]))*C2;
C2 := C/2.e0;
for J:=1 to M do
 begin
  RINT[0+(J-1)*N] := 0.e0;
_20:
 end;
RINT[1+0*N] := 0.e0;
for J:=3 to M do
 begin
  A[2] := AR(F[0+(J-1)*N],F[1+(J-1)*N],F[2+(J-1)*N],F[3+(J-1)*N]);
  RINT[1+(J-1)*N] := RINT[1+(J-3)*N] + (F[0+(J-3)*N] + F[1+(J-3)*N] + F[0+(J-1)*N] +
    F[1+(J-1)*N] + 16.e0*A[1] + 4.e0*(A[0] + A[2] +
    F[0+(J-2)*N] + F[1+(J-2)*N]))*C2;
  A[0] := A[1];
  A[1] := A[2];
_30:
 end;
for I:=3 to N do
 begin
  A3 := AR(F[(I-1)+0*N],F[(I-1)+1*N],F[(I-1)+2*N],F[(I-1)+3*N]);
  RINT[(I-1)+0*N] := 0.e0;
  RINT[(I-1)+1*N] := (F[(I-3)+0*N] + F[(I-3)+1*N] + F[(I-1)+0*N] + F[(I-1)+1*N] +
    16.e0*A2 + 4.e0*(A1 + A3 + F[(I-2)+0*N] + F[(I-2)+1*N]
    ))*C2;
  A1 := A2;
  A2 := A3;
  for J:=3 to M do
   begin
    RINT[(I-1)+(J-1)*N] := RINT[(I-1)+(J-3)*N] + (F[(I-1)+(J-1)*N] + F[(I-1)+(J-3)*N] + F[(I-3)+(J-1)*N]
    + F[(I-3)+(J-3)*N] + 16.e0*F[(I-2)+(J-2)*N] + 4.e0*
    (F[(I-2)+(J-1)*N] + F[(I-2)+(J-3)*N] + F[(I-1)+(J-2)*N] +
    F[(I-3)+(J-2)*N]))*C;
_40:
   end;
_50:
 end;
for I:=3 to N do
 begin
  for J:=3 to M do
   begin
    RINT[(I-1)+(J-1)*N] := RINT[(I-1)+(J-1)*N] + RINT[(I-3)+(J-1)*N];
_60:
   end;
_70:
 end;
end;

end.
